<!doctype html>
<html lang="es">

<head>
    <meta charset='utf-8'>
    <title>Estilos: Grid</title>
    <link rel='stylesheet' href='css/style.css'>
    <link rel='stylesheet' href='css/print.css' media='print'>
</head>

<body>


    <article class='reveal'>

        <section data-bespoke-state='portada'>
            <h1>Estilos: Grid</h1>
        </section>

        <section data-bespoke-state='clean'>
            <h2>Introducción</h2>
            <ul class="lista">
                <li>Cuadrículas</li>
                <li>Permite definir filas y columnas</li>
                <li>Dos objetos:
                    <ul>
                        <li>Contenedor (exterior)</li>
                        <li>Elementos (hijos del contenedor)</li>
                    </ul>
                </li>
            </ul>
            <h3><a href="https://cssgridgarden.com/#es">Juego</a></h3>
        </section>

        <section data-bespoke-state='clean'>
            <h2>Contenedor</h2>
            <ul class="lista">
                <li>Etiqueta que contendrá los elementos grid</li>
                <li>Para aplicarlo:
                    <ul>
                        <li><span class="propiedad">display:</span> <span class="valor-css">grid</span>, para contenedor de tipo bloque</li>
                        <li><span class="propiedad">display:</span> <span class="valor-css">inline-grid</span>, para contenedor en linea</li>
                    </ul>
                </li>
            </ul>
        </section>

        <section data-bespoke-state='clean'>
            <h2><span class="propiedad">grid-template-columns</span></h2>
            <ul class="lista">
                <li>Establece la forma en la que se repartirán las columnas</li>
                <li>Valores separados por espacios:
                    <ul>
                        <li>Unidad de medida</li>
                        <li><span class="valor-css">auto</span>, coge el tamaño restante</li>
                        <li><span class="valor-css">[x]fr</span>, entre todas las fracciones, asignar [x] al elemento</li>
                        <li><span class="valor-css">repeat([veces], unidad)</span>, repetir la unidad las veces indicadas</li>
                    </ul>
                </li>
            </ul>
        </section>

        <section data-bespoke-state='clean'>
            <h2><a href="ejemplos/p21_grid_template_columns.html" target="_blank">Ejemplos</a>
                <input type="range" onchange="resize(this, 'grid_template_columns')" min="300" max="800" step="10" value="400"></h2>
            <iframe id="grid_template_columns" src="ejemplos/p21_grid_template_columns.html" style="height: 95%; width: 400px;"></iframe>
        </section>

        <section data-bespoke-state='clean'>
            <h2><span class="propiedad">grid-template-rows</span></h2>
            <ul class="lista">
                <li>Establece la forma en la que se repartirán las filas</li>
                <li>Valores separados por espacios:
                    <ul>
                        <li>Unidad de medida</li>
                        <li><span class="valor-css">auto</span>, coge el tamaño restante</li>
                        <li><span class="valor-css">[x]fr</span>, entre todas las fracciones, asignar [x] al elemento</li>
                        <li><span class="valor-css">repeat([veces], unidad)</span>, repetir la unidad las [veces] indicadas</li>
                    </ul>
                </li>
                <li>Si se definen menos, <span class="valor-css">auto</span> al resto</li>
            </ul>
        </section>

        <section data-bespoke-state='clean'>
            <h2><a href="ejemplos/p21_grid_template_rows.html" target="_blank">Ejemplos</a></h2>
            <iframe src="ejemplos/p21_grid_template_rows.html" style="height: 95%; width: 800px;"></iframe>
        </section>

        <section data-bespoke-state='clean'>
            <h2>Areas Grid</h2>
            <ul class="lista">
                <li>Permite asignar nombres a áreas y ordenarlas</li>
                <li>Se requiere dos propiedades:
                    <ul>
                        <li>Contenedor, <span class="propiedad">grid-template-areas</span>, con el diseño
                            <ul>
                                <li>Cada línea agrupada por ""</li>
                            </ul>
                        </li>
                        <li>Elementos, <span class="propiedad">grid-area</span>, con el nombre del área</li>
                    </ul>
                </li>
            </ul>
            <h3>Ejemplo</h3>
            <pre><code><span class="selector">.grid1</span> {
    <span class="propiedad">grid-template-areas:</span> <span class="valor-css">"cabecera cabecera cabecera"
                        "cuerpo cuerpo publicidad"
                        "pie pie pie"</span>;
}
<span class="selector">.cabecera</span> {<span class="propiedad">grid-area:</span> <span class="valor-css">cabecera;</span>}
<span class="selector">.cuerpo</span> {<span class="propiedad">grid-area:</span> <span class="valor-css">cuerpo;</span>}
<span class="selector">.publicidad</span> {<span class="propiedad">grid-area:</span> <span class="valor-css">publicidad;</span>}
<span class="selector">.pie</span> {<span class="propiedad">grid-area:</span> <span class="valor-css">pie;</span>}</code></pre>
        </section>

        <section data-bespoke-state='clean'>
            <h2><a href="ejemplos/p21_grid_template_areas.html" target="_blank">Ejemplos</a></h2>
            <iframe src="ejemplos/p21_grid_template_areas.html" style="height: 95%; width: 800px;"></iframe>
        </section>
    </article>

    <script src='js/slides.keys.js'></script>
    <script src='js/slides.classes.js'></script>
    <script src='js/slides.state.js'></script>
    <script src='js/slides.kernel.js'></script>
    <script src='js/slides.jump.js'></script>
    <script src='js/slides.swipe.js'></script>

    <script>
        const {
            Deck,
            classes,
            keys,
            state,
            jump,
            swipe
        } = S6;
        const deck = new Deck({
            parent: 'article',
            plugins: [classes(), keys(), state(), jump(), swipe()]
        });

        function resize(control, idContenedor) {
            var x = document.getElementById(idContenedor);
            x.style.width = control.value + "px";
        }
    </script>
</body>

</html>